//avrdude -c usbtiny -p t25 -V -U lfuse:w:0xe2:m -U hfuse:w:0xdf:m -U efuse:w:0xff:m
#include <avr/wdt.h>
#include <TinyWireS.h>  // https://github.com/rambo/TinyWire/tree/master/TinyWireS

#define I2C_ADDRESS  1
#define ADC_SAMPLES  12
#define LED_PORT     3

volatile uint16_t adc = 0;

void request()
{
  static uint8_t pos = 0;

  TinyWireS.send(pos++ ? lowByte(adc) : highByte(adc));
  if (pos > 1)
  {
    pos = 0;
    digitalWrite(LED_PORT, !digitalRead(LED_PORT));
  }
}

void setup ()
{
  wdt_enable(WDTO_30MS);

  TinyWireS.begin(I2C_ADDRESS);
  TinyWireS.onRequest(request);
  
  pinMode(LED_PORT, OUTPUT);
  digitalWrite(LED_PORT, LOW);
}


void loop ()
{
  static uint16_t samp[ADC_SAMPLES] = { 0 };
  static uint8_t idx = 0;
  static uint16_t sum = 0;

  wdt_reset();
  
  sum -= samp[idx];
  samp[idx] = analogRead(A2);
  sum += samp[idx];
  if (++idx >= ADC_SAMPLES) idx = 0;
  adc = sum / ADC_SAMPLES;
  
  tws_delay(2);
}

/* ATMEGA328

  Wire.requestFrom(MPX_ADDR, 2);

    uint8_t high = Wire.read();
    uint8_t low = Wire.read();
    uint16_t val = (high << 8) | low;
    float volt = (val - MPX_OFFSET) * (5.0 / 1023.0);
    float kpa = volt / 0.045;
    float torr = kpa * 7.501;

http://cache.freescale.com/files/sensors/doc/data_sheet/MPX5100.pdf
http://www.nxp.com/files/sensors/doc/app_note/AN1646.pdf

*/
